// Fill out your copyright notice in the Description page of Project Settings.


#include "Asteroid.h"
#include "Components/StaticMeshComponent.h"
#include "GameFramework/ProjectileMovementComponent.h"

// Sets default values
AAsteroid::AAsteroid()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;

	// Static mesh.
	MeshComponent = CreateDefaultSubobject<UStaticMeshComponent>(TEXT("MeshComponent"));
	SetRootComponent(MeshComponent);
}

// Called when the game starts or when spawned
void AAsteroid::BeginPlay()
{
	Super::BeginPlay();
	float VelX, VelY, VelZ;

	VelX = FMath::RandRange(-500, 500);
	VelY = FMath::RandRange(-500, 500);
	VelZ = FMath::RandRange(-500, 500);

	_AsteroidVelocity = FVector(VelX,VelY,VelZ); //FVector(FMath::RandRange(int32 min, int32 max) ,100.0f,100.0f);
	//_AsteroidVelocity = FVector(100.0f,100.0f,100.0f);
}

// Called every frame
void AAsteroid::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);

	_AsteroidLocation = _AsteroidLocation + DeltaTime * _AsteroidVelocity;

	SetActorLocation(_AsteroidLocation);
}

void AAsteroid::SetAsteroidLocation(FVector Location)
{
	_AsteroidLocation = Location;
}

void AAsteroid::SetAsteroidVelocity(FVector Velocity)
{
	_AsteroidVelocity = Velocity;
}

FVector AAsteroid::GetAsteroidVelocity()
{
	return _AsteroidVelocity;
}

float AAsteroid::GetAsteroidRadius()
{
	return _AsteroidRadius;
}