// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Asteroid.generated.h"

UCLASS()
class NM_SCC_TEAMUNREAL_API AAsteroid : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	AAsteroid();

	UPROPERTY(EditAnywhere, Category = "C++ Components")
	class UStaticMeshComponent* MeshComponent;

	//UPROPERTY(EditAnywhere, Category = "C++ Components")
	//class UProjectileMovementComponent* AsteroidMovement;

protected:
	FVector _AsteroidLocation;
	FVector _AsteroidVelocity;
	float _AsteroidRadius;

	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	UFUNCTION(BlueprintCallable)
	void SetAsteroidLocation(FVector Location);

	//UFUNCTION(BlueprintCallable)
	//FVector GetAsteroidLocation();

	UFUNCTION(BlueprintCallable)
	void SetAsteroidVelocity(FVector Velocity);

	UFUNCTION(BlueprintCallable)
	FVector GetAsteroidVelocity();

	UFUNCTION(BlueprintCallable)
	float GetAsteroidRadius();

};
