// Fill out your copyright notice in the Description page of Project Settings.


#include "ShuttleWayPoint.h"
#include "Components/StaticMeshComponent.h"

// Sets default values
AShuttleWayPoint::AShuttleWayPoint()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;

	// Mesh config.
	MeshComponent = CreateDefaultSubobject<UStaticMeshComponent>(TEXT("MeshComponent"));
	SetRootComponent(MeshComponent);

	// Initialize Asteroid Pointer.
	AsteroidToAvoid = nullptr;
}

// Called when the game starts or when spawned
void AShuttleWayPoint::BeginPlay()
{
	Super::BeginPlay();
	
}

// Called every frame
void AShuttleWayPoint::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);

}

void AShuttleWayPoint::AssignAsteroid(AActor* Asteroid)
{
	// Note which Asteroid this Waypoint is Avoiding.
	AsteroidToAvoid = Asteroid;
}

AActor* AShuttleWayPoint::GetAsteroidToAvoid()
{
	return AsteroidToAvoid;
}

void AShuttleWayPoint::DestroyProcess()
{
	// Destroy the Waypoint object, carefully. Source: "Unreal Engine 5 Game Development With C++ Scripting", p. 194
	PrimaryActorTick.bCanEverTick = false;
	K2_DestroyActor();
	GEngine->ForceGarbageCollection(true);
}
