// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"

/**
 * 
 */
class NM_SCC_TEAMUNREAL_API Wayfinding
{
public:
	// How far out the shuttle will look for path-finding.
	float PlanningDistance;
	float SafetyMargin;
	float ShuttleRadius;

	Wayfinding(FVector EndLocation, UWorld* World);

	unsigned char Update(const class AShuttle* ShuttlePawn, UWorld* World);

	class AShuttleWayPoint* SpawnWaypoint(FVector Location, AActor* Asteroid, UWorld* World);

	FVector GetCurrentWaypointLocation();

	void OnWaypointCollision(class AShuttleWayPoint* Waypoint);

	bool WayFindingComplete();

	class AAsteroid* GetCurrentAsteroid();

	~Wayfinding();

protected:
	// Keep references to existing waypoints.
	AShuttleWayPoint* _FinalDestination;
	AShuttleWayPoint* _IntermediateWaypoint;
	class AAsteroid* _CurrentAsteroid;
	AActor* _LastAsteroid;
	TArray<class AShuttleWayPoint *> _WaypointQueue;
	int _WaypointCount;

	FVector ComputeNewWaypointLocation(FVector HitLocation, float VectorModifier, const class AShuttle *ShuttlePawn, class AAsteroid* Asteroid, const UWorld *World);

	FVector CreateAvoidanceWaypointLocation(FVector ShuttleLocation, FVector NextDestination, FVector AsteroidCollionLocation, float AsteroidRadius);
};
